<?php
/**
* @version		$Id: helper.php 14401 2010-01-26 14:10:00Z louis $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Incluindo o mod_mainmenu do Joomla Framework
require_once JPATH_BASE.DS.'modules'.DS.'mod_mainmenu'.DS.'helper.php';

// Extendendo a classe do modMainMenuHelper do mod_meinmenu com uma nova classe
class modMainMenuCatHelper extends modMainMenuHelper {
	function render(&$params, $callback) {		
		$xml = modMainMenuHelper::getXML($params->get('menutype'), $params, $callback);
		if ($xml) {
			// Tratando opcoes padrao do mod_mainmenu e css's para mudanca de layout
			if ($class = $params->get('class_sfx')) {			
				$xml->addAttribute('class', $params->get('class_sfx'));
			}
			if ($tagId = $params->get('tag_id')) {
				$xml->addAttribute('id', $tagId);
			}
			
			$cssfile = Array( 1 => $params->get('cssfile1'), 2 => $params->get('cssfile2'), 3 => $params->get('cssfile3'), 4 => $params->get('cssfile4'), 5 => $params->get('cssfile5') );
			
            // Tratando tags e espacos em branco
			$result = JFilterOutput::ampReplace($xml->toString((bool)$params->get('show_whitespace')));
			$result = str_replace(array('<span>', '</span>','<ul>','</ul>'), '', $result);
			
			// Checando opcao de sef da configuracao do Joomla
			$sef_status = & JApplication::getCfg('sef');
			
			// Selecionando dados do menu
			$menu = & JSite::getMenu();
			$rows = $menu->getItems('menutype', $params->get('menutype'));
			foreach ($rows as $row)
			{
				// Pegando parametros do item de menu
				$iParams = new JParameter($row->params);
				
				// Tratando items do menu pela ordem de apresentacao							
				switch ($row->ordering) {
				
					case 1:
						$result = str_replace('<li class="first-child item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
						if ($sef_status == 0) $result = str_replace('Itemid=' . $row->id . '">' . $row->name . '</a></li>', 'Itemid=' . $row->id . '&cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
						if ($sef_status == 1) $result = str_replace('/index.php/' . $row->alias . '">' . $row->name . '</a></li>', '/index.php/' . $row->alias . '?cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
					case 2:
						$result = str_replace('<li class="item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
						if ($sef_status == 0) $result = str_replace('Itemid=' . $row->id . '">' . $row->name . '</a></li>', 'Itemid=' . $row->id . '&cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
						if ($sef_status == 1) $result = str_replace('/index.php/' . $row->alias . '">' . $row->name . '</a></li>', '/index.php/' . $row->alias . '?cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
					case 3:
						$result = str_replace('<li class="item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
						if ($sef_status == 0) $result = str_replace('Itemid=' . $row->id . '">' . $row->name . '</a></li>', 'Itemid=' . $row->id . '&cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
						if ($sef_status == 1) $result = str_replace('/index.php/' . $row->alias . '">' . $row->name . '</a></li>', '/index.php/' . $row->alias . '?cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
					case 4:
						$result = str_replace('<li class="item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
						if ($sef_status == 0) $result = str_replace('Itemid=' . $row->id . '">' . $row->name . '</a></li>', 'Itemid=' . $row->id . '&cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
						if ($sef_status == 1) $result = str_replace('/index.php/' . $row->alias . '">' . $row->name . '</a></li>', '/index.php/' . $row->alias . '?cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
					case 5:
						if ( count($rows) > 5 ){
							$result = str_replace('<li class="item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
							if ($sef_status == 0) $result = str_replace('Itemid=' . $row->id . '">' . $row->name . '</a></li>', 'Itemid=' . $row->id . '&cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
							if ($sef_status == 1) $result = str_replace('/index.php/' . $row->alias . '">' . $row->name . '</a></li>', '/index.php/' . $row->alias . '?cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
						} else {
							$result = str_replace('<li class="last-child item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
							if ($sef_status == 0) $result = str_replace('Itemid=' . $row->id . '">' . $row->name . '</a></li>', 'Itemid=' . $row->id . '&cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
							if ($sef_status == 1) $result = str_replace('/index.php/' . $row->alias . '">' . $row->name . '</a></li>', '/index.php/' . $row->alias . '?cssfile=' . $cssfile[$row->ordering] . '">' . $row->name . '<span>' . $iParams->get('page_title') . '</span></a></div>', $result);
						}	
					
				}	
				// Tratando item ativo
				$result = str_replace('<li id="current" class="first-child active item' . $row->id . '"><a ' , '<div><a   id="portaltab-' . $row->ordering  . '" ', $result);			
				$result = str_replace('<li id="current" class="active item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
				$result = str_replace('<li id="current" class="last-child active item' . $row->id . '"><a ' , '<div><a id="portaltab-' . $row->ordering  . '" ', $result);
			}
			// Tratando a eliminacao dos outros itens
			$result = preg_replace('/<li(.*?)\/li>/is', '', $result);
			
			// Imprimindo o resultado
			echo $result."\n";

		}	

	}		 

}
?>